
import 'dart:async';

import 'package:flutter/services.dart';


class FlutterAliCloudAuth {
  static const MethodChannel _channel = const MethodChannel('flutter_ali_cloud_auth');
  static int idPool = 1;
  static Map<int, Function> callbacks = {};
  static Future<bool> init() async {
    Future<void> _methodCallHandler(MethodCall call) async {
      print("_methodCallHandler call");
      print(call.toString());
      if (call.method == "RPVerifyFinish") {
        int callId = call.arguments['callId'];
        String token = call.arguments['token'];
        int result = call.arguments['result'];
        String resultCode = call.arguments['resultCode'];
        String resultMsg = call.arguments['resultMsg'];
        if (callbacks[callId] != null) {
          callbacks[callId](token, result, resultCode, resultMsg, callId);
        } else {
          print("error! bad callId" + callId.toString());
        }
      } else if (call.method == "test") {
        print('call test!!!test!!!');
        Map ret = {};
        ret['code'] = '22';
        ret['data'] = {"msg": "good"};
        return ret;
      }
    }

    _channel.setMethodCallHandler(_methodCallHandler);
    return true;
  }

  static Future<Map> startAuth(String token, Function resultCallback) async {
    print("call startAuth in plugin dart");
    idPool += 1;
    callbacks[idPool] = resultCallback;
    print("call _channel startAuth in plugin dart,gogogog!!!");
    final Map ret = await _channel
        .invokeMethod('startAuth', {"token": token, "callId": idPool});
    ret['callId'] = idPool;
    return ret;
  }
  static Future<Map> startAuthNative(String token, Function resultCallback) async {
    print("call startAuth in plugin dart");
    idPool += 1;
    callbacks[idPool] = resultCallback;
    print("call _channel startAuth in plugin dart,gogogog!!!");
    final Map ret = await _channel
        .invokeMethod('startAuthNative', {"token": token, "callId": idPool});
    ret['callId'] = idPool;
    return ret;
  }
}

